/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
 * Copyright (c) 2011-2012, Freescale Semiconductor, Inc. All rights reserved. 
 *
 */


/*
 * Module Name:    gstsutils.h
 *
 * Description:    simple utils head file for gst plugins
 *
 * Portability:    This code is written for Linux OS and Gstreamer
 */

/*
 * Changelog:
 *
 */

#include <gst/gst.h>

#ifndef __GST_SUTILS__
#define __GST_SUTILS__

typedef struct
{
  gint id;
  gchar *name;
  gchar *nickname;
  gchar *desc;
  GType gtype;
  int offset;
  char *def;
  char *min;
  char *max;
} GstsutilsOptionEntry;
void
gstsutils_options_install_properties_by_options (GstsutilsOptionEntry * table,
    GObjectClass * oclass);
gboolean
gstsutils_options_get_option (GstsutilsOptionEntry * table, gchar * option,
    guint id, GValue * value);
gboolean gstsutils_options_set_option (GstsutilsOptionEntry * table,
    gchar * option, guint id, GValue * value);
void gstsutils_options_load_default (GstsutilsOptionEntry * table,
    gchar * option);
gboolean gstsutils_options_load_from_keyfile (GstsutilsOptionEntry * table,
    gchar * option, gchar * filename, gchar * group);

gboolean
gstsutils_elementutil_get_int (gchar * filename, gchar * group, gchar * field,
    gint * value);


#endif
